<?xml version="1.0" encoding="UTF-8"?>
<!--
        Copyright  1990-2007 Sun Microsystems, Inc. All Rights Reserved.
        SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
-->
<!--
    This stylesheet generates source code of
    com.sun.midp.security.PermissionsTable
    class.
-->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text"/>

<!-- stylesheet parameter: output file type (java | native) -->
<xsl:param name="output">error</xsl:param>

<xsl:template match="/">
<xsl:text>/*
 * Copyright  1990-2007 Sun Microsystems, Inc. All Rights Reserved.
 * SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 *
 */

/*
 * This file is automatically generated. Do not edit.
 */

</xsl:text>
<xsl:if test="$output='java'">
<xsl:text>package com.sun.midp.security;

import com.sun.midp.i18n.ResourceConstants;

public final class PermissionsTable {</xsl:text>
</xsl:if>
<xsl:variable name="perm_ids">
    <xsl:for-each select="/configuration/permissions/group">
        <xsl:for-each select="permission">
<xsl:text>
    /** </xsl:text>
<xsl:value-of select="@Name"/>
<xsl:text> permission ID. */
    public static final int </xsl:text>
<xsl:value-of select="@ID"/>
<xsl:text> = </xsl:text>
<xsl:text>;</xsl:text>
        </xsl:for-each>
    </xsl:for-each>
</xsl:variable>

<xsl:variable name="perm_number" select="55"/>

<xsl:if test="$output='native'">
<xsl:text>/** Total number of permissions. */
#define NUMBER_OF_PERMISSIONS    </xsl:text>
    <xsl:call-template name="generateNumberOfPermissions">
        <xsl:with-param name="text" select="$perm_ids"/>
        <xsl:with-param name="nextID" select="$perm_number"/>
    </xsl:call-template>
<xsl:text>
</xsl:text>
</xsl:if>

<xsl:if test="$output='java'">
    <xsl:call-template name="generateIDs">
        <xsl:with-param name="text" select="$perm_ids"/>
        <xsl:with-param name="nextID" select="$perm_number"/>
    </xsl:call-template>

<xsl:text>
    /** Permission specifications. */
    static final PermissionSpec[] permissionSpecs = {
        new PermissionSpec(Permissions.MIDP_PERMISSION_NAME, Permissions.NEVER_GROUP),
        new PermissionSpec(Permissions.AMS_PERMISSION_NAME, Permissions.NEVER_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.http",
            Permissions.NET_ACCESS_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.socket",
            Permissions.NET_ACCESS_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.https",
            Permissions.NET_ACCESS_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.ssl",
            Permissions.NET_ACCESS_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.serversocket",
            Permissions.NET_ACCESS_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.datagram",
            Permissions.NET_ACCESS_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.datagramreceiver",
            Permissions.NET_ACCESS_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.comm",
            Permissions.LOCAL_CONN_GROUP),
        new PermissionSpec("javax.microedition.io.PushRegistry",
            Permissions.AUTO_INVOCATION_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.sms",
            Permissions.READ_MESSAGE_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.cbs",
            Permissions.READ_MESSAGE_GROUP),
        new PermissionSpec("javax.wireless.messaging.sms.send",
            Permissions.SEND_MESSAGE_GROUP),
        new PermissionSpec("javax.wireless.messaging.sms.receive",
            Permissions.READ_MESSAGE_GROUP),
        new PermissionSpec("javax.wireless.messaging.cbs.receive",
            Permissions.READ_MESSAGE_GROUP),
        new PermissionSpec("javax.microedition.media.control.RecordControl",
            Permissions.MULTIMEDIA_GROUP),
        new PermissionSpec(
            "javax.microedition.media.control.VideoControl.getSnapshot",
            Permissions.MULTIMEDIA_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.mms",
            Permissions.READ_MESSAGE_GROUP),
        new PermissionSpec("javax.wireless.messaging.mms.send",
            Permissions.SEND_MESSAGE_GROUP),
        new PermissionSpec("javax.wireless.messaging.mms.receive",
            Permissions.READ_MESSAGE_GROUP),
        new PermissionSpec("javax.microedition.apdu.aid",
            Permissions.SMART_CARD_GROUP),
        new PermissionSpec("javax.microedition.jcrmi",
            Permissions.SMART_CARD_GROUP),
        new PermissionSpec(
            "javax.microedition.securityservice.CMSMessageSignatureService",
            Permissions.AUTHENTICATION_GROUP),
        new PermissionSpec("javax.microedition.apdu.sat",
            Permissions.SMART_CARD_GROUP),
        new PermissionSpec("javax.microedition.content.ContentHandler",
            Permissions.AUTO_INVOCATION_GROUP),
        new PermissionSpec("javax.microedition.pim.ContactList.read",
            Permissions.READ_USER_DATA_GROUP),
        new PermissionSpec("javax.microedition.pim.ContactList.write",
            Permissions.WRITE_USER_DATA_GROUP),
        new PermissionSpec("javax.microedition.pim.EventList.read",
            Permissions.READ_USER_DATA_GROUP),
        new PermissionSpec("javax.microedition.pim.EventList.write",
            Permissions.WRITE_USER_DATA_GROUP),
        new PermissionSpec("javax.microedition.pim.ToDoList.read",
            Permissions.READ_USER_DATA_GROUP),
        new PermissionSpec("javax.microedition.pim.ToDoList.write",
            Permissions.WRITE_USER_DATA_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.file.read",
            Permissions.READ_USER_DATA_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.file.write",
            Permissions.WRITE_USER_DATA_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.obex.client",
            Permissions.LOCAL_CONN_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.obex.server",
            Permissions.LOCAL_CONN_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.obex.client.tcp",
            Permissions.LOCAL_CONN_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.obex.server.tcp",
            Permissions.LOCAL_CONN_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.bluetooth.client",
            Permissions.LOCAL_CONN_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.bluetooth.server",
            Permissions.LOCAL_CONN_GROUP),
        new PermissionSpec("javax.microedition.location.Location",
            Permissions.LOCATION_GROUP),
        new PermissionSpec("javax.microedition.location.Orientation",
            Permissions.LOCATION_GROUP),
        new PermissionSpec("javax.microedition.location.ProximityListener",
            Permissions.LOCATION_GROUP),
        new PermissionSpec("javax.microedition.location.LandmarkStore.read",
            Permissions.LANDMARK_GROUP),
        new PermissionSpec("javax.microedition.location.LandmarkStore.write",
            Permissions.LANDMARK_GROUP),
        new PermissionSpec(
            "javax.microedition.location.LandmarkStore.category",
            Permissions.LANDMARK_GROUP),
        new PermissionSpec(
            "javax.microedition.location.LandmarkStore.management",
            Permissions.LANDMARK_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.sip",
            Permissions.CALL_CONTROL_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.sips",
            Permissions.CALL_CONTROL_GROUP),
        new PermissionSpec("javax.microedition.payment.process",
            Permissions.ID_ALLOWED_GROUP),
        new PermissionSpec(
            "javax.microedition.amms.control.camera.enableShutterFeedback",
            Permissions.MULTIMEDIA_GROUP),
        new PermissionSpec(
            "javax.microedition.amms.control.tuner.setPreset",
            Permissions.WRITE_USER_DATA_GROUP),
        new PermissionSpec("javax.microedition.io.Connector.sensor",
            Permissions.SENSOR_GROUP),
        new PermissionSpec("javax.microedition.sensor.PrivateSensor",
            Permissions.SENSOR_GROUP),
        new PermissionSpec("javax.microedition.sensor.ProtectedSensor",
            Permissions.SENSOR_GROUP),
</xsl:text>
        <xsl:for-each select="/configuration/permissions/group">
            <xsl:for-each select="permission">
<xsl:text>        new PermissionSpec("</xsl:text>
<xsl:value-of select="@Name"/>
<xsl:text>",
            Permissions.</xsl:text>
<xsl:value-of select="../@ID"/>
<xsl:text>),
</xsl:text>
            </xsl:for-each>
        </xsl:for-each>
<xsl:text>    };
}
</xsl:text>
</xsl:if>
</xsl:template>

<xsl:template name="generateIDs">
    <xsl:param name="text"/>
    <xsl:param name="nextID"/>
<xsl:choose>
    <!-- when there is more than one element in the list -->
    <xsl:when test="contains($text,';')">
        <xsl:value-of select="substring-before($text,';')"/>
        <xsl:value-of select="$nextID"/>
<xsl:text>;</xsl:text>
        <xsl:call-template name="generateIDs">
            <xsl:with-param name="text" select="substring-after($text,';')"/>
            <xsl:with-param name="nextID" select="$nextID + 1"/>
        </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
<xsl:text>

    /** Number of permissions. */
    public static final int NUMBER_OF_PERMISSIONS = </xsl:text>
        <xsl:value-of select="$nextID"/>
<xsl:text>;
</xsl:text>
    </xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template name="generateNumberOfPermissions">
    <xsl:param name="text"/>
    <xsl:param name="nextID"/>
<xsl:choose>
    <!-- when there is more than one element in the list -->
    <xsl:when test="contains($text,';')">
        <xsl:call-template name="generateNumberOfPermissions">
            <xsl:with-param name="text" select="substring-after($text,';')"/>
            <xsl:with-param name="nextID" select="$nextID + 1"/>
        </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
        <xsl:value-of select="$nextID"/>
    </xsl:otherwise>
</xsl:choose>
</xsl:template>

</xsl:stylesheet>
